(function() {
	var tad = window.tad = {};
	
	/**
	 * This method allows the ad to confirm a basic feature set before display.
	 * The version number corresponds with the API specification version and not a vendor's SDK version.
	 * @param none
	 * @returns {String} the API specification that this container is certified against
	 */
	tad.getVersion = function() {
		return "1.0";
	};
	
	/**
	 * The method will send an event to log server.
	 * @param {String}  an event code for user action.
	 * @returns none
	 */
	tad.sendEventCode = function(action) {
		TadController.sendEventCode(action);
	};
	
	tad.downloadApplication = function(downloadInfo) {
		TadController.downloadApplication(stringify(downloadInfo));
	};
	
	tad.runApplication = function(packageInfo, downloadInfo) {
		TadController.runApplication(stringify(packageInfo), stringify(downloadInfo));
	};
	
	tad.canOpenUri = function(uri) {
		return TadController.canOpenUri(uri);
	};
	
	tad.getClientId = function() {
		return TadController.getClientId();
	};
	
	/*
	tad.runApplications = function(schemeInfoList) {
		TadController.runApplications(stringify(schemeInfoList));
	};
	*/
	
	tad.playVideo = function(url) {
		TadController.playVideo(url);
	};
	
	tad.tstoreRichReward = function(url) {
		TadController.tstoreRichReward(url);
	};
	
	stringify = function(args) {
		if (typeof JSON === "undefined") {
			var s = "";
			var len = args.length;
			var i;
			if (typeof len == "undefined") {
				return stringifyArg(args);
			}
			for (i = 0; i < args.length; i++) {
				if (i > 0) {
					s = s + ",";
				}
				s = s + stringifyArg(args[i]);
			}
			s = s + "]";
			return s;
		} else {
			return JSON.stringify(args);
		}
	};

	stringifyArg = function(arg) {
		var s, type, start, name, nameType, a;
		type = typeof arg;
		s = "";
		if ((type === "number") || (type === "boolean")) {
			s = s + args;
		} else if (arg instanceof Array) {
			s = s + "[" + arg + "]";
		} else if (arg instanceof Object) {
			start = true;
			s = s + '{';
			for (name in arg) {
				if (arg[name] !== null) {
					if (!start) {
						s = s + ',';
					}
					s = s + '"' + name + '":';
					nameType = typeof arg[name];
					if ((nameType === "number") || (nameType === "boolean")) {
						s = s + arg[name];
					} else if ((typeof arg[name]) === 'function') {
						// don't copy the functions
						s = s + '""';
					} else if (arg[name] instanceof Object) {
						s = s + this.stringify(args[i][name]);
					} else {
						s = s + '"' + arg[name] + '"';
					}
					start = false;
				}
			}
			s = s + '}';
		} else {
			a = arg.replace(/\\/g, '\\\\');
			a = a.replace(/"/g, '\\"');
			s = s + '"' + a + '"';
		}
		
		return s;
	};
})();
